<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:import href="copy-config-template.xsl"/>
<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
  
<!-- Input Parameters -->
<xsl:param name="VOView" select="'true'"/>
<xsl:param name="ChannelView" select="'true'"/>
<xsl:param name="CredentialisView" select="'true'"/>

<!-- Process the VOView or Channel View Parameters -->
<xsl:template match="param[@name='VOView' or 
                           @name='ChannelView' or
                           @name='CredentialsView']" priority="2">
 <xsl:copy>
  <xsl:copy-of select="@name"/>
  <xsl:copy-of select="@type"/>
  <xsl:attribute name="mandatory">fixed</xsl:attribute>
  <xsl:attribute name="level">expert</xsl:attribute>
  <xsl:text>&#xA;</xsl:text>
  <xsl:apply-templates select="description"/>
  <xsl:text>&#xA;</xsl:text>
  <xsl:if test="@name='VOView'">
    <xsl:element name="value">
      <xsl:value-of select="$VOView"/>
    </xsl:element>
  </xsl:if>
  <xsl:if test="@name='ChannelView'">
    <xsl:element name="value">
      <xsl:value-of select="$ChannelView"/>
    </xsl:element>
  </xsl:if>
  <xsl:if test="@name='CredentialsView'">
    <xsl:element name="value">
      <xsl:value-of select="$CredentialsView"/>
    </xsl:element>
  </xsl:if>
  <xsl:text>&#xA;</xsl:text>
 </xsl:copy>
</xsl:template>

<!-- Start the macthing -->
<xsl:template match="/">
  <xsl:apply-templates/>
</xsl:template>

</xsl:stylesheet>
