<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:import href="copy-config-template.xsl"/>
<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>
  
<!-- Input Parameters -->
<xsl:param name="UseFps"            select="'false'"/>
<xsl:param name="UsePythonRetry" select="'false'"/>

<!-- Process the DeploymentType Parameter -->
<xsl:template match="param[@name='DeploymentType']" priority="2">
 <xsl:copy>
  <xsl:copy-of select="@name"/>
  <xsl:copy-of select="@type"/>
  <xsl:attribute name="mandatory">fixed</xsl:attribute>
  <xsl:attribute name="level">expert</xsl:attribute>  
  <xsl:text>&#xA;</xsl:text>
  <xsl:apply-templates select="description"/>
  <xsl:text>&#xA;</xsl:text>
  <xsl:element name="value">
    <xsl:choose>
      <xsl:when test="$UseFps='true'">fps</xsl:when>
      <xsl:otherwise>fts</xsl:otherwise>
    </xsl:choose>
  </xsl:element>
  <xsl:text>&#xA;</xsl:text>
 </xsl:copy>
</xsl:template>

<!-- Process the DisableDelegationForTransfers Parameter -->
<xsl:template match="param[@name='DisableDelegationForTransfers']" priority="2">
 <xsl:copy>
  <xsl:copy-of select="@*"/>
  <xsl:text>&#xA;</xsl:text>
  <xsl:apply-templates select="description"/>
  <xsl:text>&#xA;</xsl:text>
  <xsl:element name="value">
    <xsl:choose>
      <xsl:when test="$UseFps='true'">true</xsl:when>
      <xsl:otherwise>false</xsl:otherwise>
    </xsl:choose>
  </xsl:element>
  <xsl:text>&#xA;</xsl:text>
 </xsl:copy>
</xsl:template>

<!-- Process the Retry_Type Parameter -->
<xsl:template match="param[@name='Retry_Type']" priority="2">
 <xsl:copy>
  <xsl:choose>
    <xsl:when test="$UsePythonRetry='true'">
      <xsl:copy-of select="@name"/>
      <xsl:copy-of select="@type"/>
      <xsl:attribute name="mandatory">fixed</xsl:attribute>
      <xsl:attribute name="level">expert</xsl:attribute>  
      <xsl:text>&#xA;</xsl:text>
      <xsl:apply-templates select="description"/>
      <xsl:text>&#xA;</xsl:text>
      <xsl:element name="value">glite:PythonRetry</xsl:element>
      <xsl:text>&#xA;</xsl:text>
    </xsl:when>
    <xsl:otherwise>
      <xsl:copy-of select="@*"/>
      <xsl:apply-templates/>
    </xsl:otherwise>
  </xsl:choose>
 </xsl:copy>
</xsl:template>

<!-- Start the macthing -->
<xsl:template match="/">
  <xsl:apply-templates/>
</xsl:template>

</xsl:stylesheet>
