<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:import href="../config/yaim/fta-config-bash.xsl"/>
<xsl:output method="text" encoding="UTF-8"/>

<!-- ***************************************************************************
                                component template
**************************************************************************** -->
<xsl:template match="component">
    <xsl:variable name="component_name" select="@name"/>
<!--Component : <xsl:value-of select="$component_name"/>-->
    <!-- get the prefix for the component -->
    <xsl:variable name="param_prefix">
        <xsl:call-template name="GetPrefix">
            <xsl:with-param name="node" select="."/>
        </xsl:call-template>
    </xsl:variable>
<!--Prefix : <xsl:value-of select="$param_prefix"/>-->
    <xsl:for-each select="config-template/init/param[@name][not (@level) or @level!='expert'][not (@mandatory) or @mandatory!='fixed']">
        <xsl:variable name="bash_name">
            <xsl:value-of select="translate(@name,$lcletters,$ucletters)"/>
        </xsl:variable>
   * <xsl:value-of select="$param_prefix"/><xsl:value-of select="$bash_name"/> <xsl:if test="@level"> [<xsl:value-of select="@level"/>]</xsl:if><xsl:if test="@mandatory='true'">, mandatory</xsl:if>, <xsl:value-of select="@type"/>: <xsl:value-of select="description"/>

    </xsl:for-each>

<!--        
<para><xsl:value-of select="config-template/description"/></para>
<variablelist>
    <varlistentry>
        <term>Library:</term>
        <listitem><para><xsl:value-of select="config-template/lib"/></para></listitem>
    </varlistentry>
    <varlistentry>
        <term>Initialization:</term>
        <listitem>
            <xsl:if test="not(config-template/init)">
                <para><xsl:text>&lt;No initialization parameters&gt;</xsl:text></para>
            </xsl:if>
            <xsl:apply-templates select="config-template/init"/>
        </listitem>
    </varlistentry>
    <varlistentry>
        <term>Configuration:</term>
        <listitem>
            <xsl:if test="not(config-template/config)">
                <para><xsl:text>&lt;No configuration parameters&gt;</xsl:text></para>
            </xsl:if>
            <xsl:apply-templates select="config-template/config"/>
        </listitem>
    </varlistentry>
</variablelist>
</sect2>
-->
</xsl:template>
<!--
<xsl:template match="init|config">
    <variablelist>
        <xsl:apply-templates select="param"/>
    </variablelist>
</xsl:template>

<xsl:template match="param">
    <varlistentry>
        <term>
            <xsl:value-of select="@name"/>
            <xsl:text> [</xsl:text>
            <xsl:value-of select="@level"/>
            <xsl:if test="@mandatory = 'true'">
                <xsl:text>/mandatory</xsl:text>
            </xsl:if>
            <xsl:text>]</xsl:text>
        </term>
        <listitem>
            <para><xsl:value-of select="description"/></para>
            <para>
                <xsl:text>Type: </xsl:text><xsl:value-of select="@type"/><xsl:text>;</xsl:text>
                <xsl:text> Default value: '</xsl:text><xsl:value-of select="value"/><xsl:text>'</xsl:text>
                
            </para>
        </listitem>
    </varlistentry>
</xsl:template>
-->
</xsl:stylesheet>
