/*
 * Copyright (c) Members of the EGEE Collaboration. 2004.
 * See http://www.eu-egee.org/partners/ for details on the copyright holders.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *  GLite Data Transfer Agents: CancelTransfers Class
 *
 *  Authors: Paolo Badino <paolo.badino@cern.ch>
 *  Version info: $Id: Cancel.h,v 1.5 2007/07/04 13:11:58 ptedesco Exp $
 *  Release: $Name:  $
 *
 */
 
#error should be removed from CVS
 
#ifndef GLITE_DATA_TRANSFER_AGENTS_ACTION_VO_CANCEL_H_
#define GLITE_DATA_TRANSFER_AGENTS_ACTION_VO_CANCEL_H_

#include "glite/data/transfer/agent/action/vo/VOAction.h"
#include "glite/data/transfer/agent/action/ActionFactoryMethod.h"

namespace glite   {
namespace data    {
namespace transfer{
namespace agent   {
namespace action  {
namespace vo      {

/**
 * The purpose of that Action is to cancel Pending File Requests
 */
class Cancel : public VOAction {
    /*
     * Declare Action Factory Method
     */
    DECLARE_FACTORY_METHOD( Cancel , "glite:CancelPending");

public:
    /**
     * Constructor
     */
    Cancel();

    /**
     * Destructor
     */
    virtual ~Cancel();

protected:

    /**
     * Execute The Action
     */
    virtual void exec(const std::string& params,unsigned int& failures) /*throw (ExecuteException)*/;

private:
    
    /**
     * Cancel a Pending File
     */
    void cancelFile(const std::string& file_id, std::set<std::string>& ids);
    
private:
    /**
     * Copy Constructor. Not Implemented
     */
    Cancel(const Cancel&);

    /**
     * Assignment Operator. Not Implemented
     */
    Cancel& operator=(const Cancel&);
};


} // End namespace vo
} // End namespace action
} // End namespace agent
} // End namespace transfer
} // End namespace data
} // End namespace glite

#endif //GLITE_DATA_TRANSFER_AGENTS_ACTION_VO_CANCEL_H_
