DECLARE
-- Insert Channel Procedure
PROCEDURE test_create_channel(
                            n    T_CHANNEL.CHANNEL_NAME%TYPE,
                            src  T_CHANNEL.SOURCE_SITE%TYPE,
                            dst  T_CHANNEL.DEST_SITE%TYPE,
                            st   T_CHANNEL.CHANNEL_STATE%TYPE,
                            f    T_CHANNEL.NOFILES%TYPE DEFAULT 10,
                            sl   T_CHANNEL.SE_LIMIT%TYPE DEFAULT NULL)
IS          
    ch_type T_CHANNEL.CHANNEL_TYPE%TYPE;
BEGIN
    IF (src = '*' OR  dst = '*' OR src LIKE '[%]' OR dst LIKE '[%]') THEN
        ch_type := 'NONDEDICATED';
    ELSE 
        ch_type := 'DEDICATED';
    END IF;
        
    INSERT INTO t_channel(channel_name,source_site,dest_site,channel_state,nofiles,se_limit,channel_type)
        VALUES (n,src,dst,st,f,sl,ch_type);
END;


-- Insert Bad SE  Procedure
PROCEDURE test_create_bad_se(
                            n    T_BAD_SES.SE_HOSTNAME%TYPE,
                            m    T_BAD_SES.MESSAGE%TYPE,
                            dn   T_BAD_SES.ADMIN_DN%TYPE)
IS                            
BEGIN
    INSERT INTO t_bad_ses(se_hostname,message,admin_dn,addition_time)
        VALUES (n,m,dn,SYSTIMESTAMP);
END;

-- Main
BEGIN
	-- Set Records
	test_create_channel('channel_1'                 ,'TEST.CERN.CH'     ,'TEST.RAL.AC.UK'       ,'Active');
	test_create_channel('channel_2'                 ,'TEST.CERN.CH'     ,'TEST.NIKHEF.NL'       ,'Drain');
	test_create_channel('channel_3'                 ,'TEST.CERN.CH'     ,'TEST.INFN.IT'         ,'Inactive');
	test_create_channel('channel_4'                 ,'TEST.CERN.CH'     ,'TEST.IN2P3.FR'        ,'Active');
	test_create_channel('channel_5'                 ,'TEST.CERN.CH'     ,'TEST.IMPERIAL.AC.UK'  ,'Active');
	test_create_channel('channel_6'                 ,'TEST.CERN.CH'     ,'*'                    ,'Stopped');
	test_create_channel('channel_all'               ,'*'                ,'*'                    ,'Stopped');
	test_create_channel('channel_7'                 ,'TEST.CERN.CH'     ,'TEST.DESY.DE'         ,'Halted');
	test_create_channel('channel_8'                 ,'TEST.CERN.CH'     ,'TEST.FNAL.GOV'        ,'Active');
	test_create_channel('channel_9'                 ,'TEST.CERN.CH'     ,'TEST.BNL.GOV'         ,'Active');
	test_create_channel('channel_10'                ,'SITE.INFN.IT'     ,'[Tier0]'              ,'Active');
    test_create_channel('channel_11'                ,'[Grid-IT]'        ,'[Tier0]'              ,'Active');
    test_create_channel('channel_12'                ,'*'                ,'SITE.CERN.CH'         ,'Active');
	test_create_channel('ACTIVETXCACHE_channel_1'   ,'TEST1.CERN.CH'    ,'TEST1.IN2P3.FR'       ,'Active');
	test_create_channel('CHECKSTATE_channel_1'      ,'TEST2.CERN.CH'    ,'TEST2.NIKHEF.NEL'     ,'Active');
	test_create_channel('FETCH_channel_1'           ,'TEST3.CERN.CH'    ,'TEST3.RAL.AC.UK'      ,'Active',20);
	test_create_channel('FETCH_channel_2'           ,'TEST3.CERN.CH'    ,'TEST3.NIKHEF.NL'      ,'Active',20);
	test_create_channel('FETCH_channel_3'           ,'TEST5.CERN.CH'    ,'TEST5.NIKHEF.NL'      ,'Active',10);
	test_create_channel('FETCH_channel_4'           ,'TEST5.CERN.CH'    ,'*'                    ,'Active',15,3);
	test_create_channel('FETCH_channel_5'           ,'[Grid-IT]'        ,'SITE.CERN.CH'         ,'Active',6,2);
    test_create_channel('FETCH_channel_6'           ,'TEST6.CERN.CH'    ,'TEST6.INFN.IT'         ,'Active',100,20);
	test_create_channel('CANCELACTIVE_channel_1'    ,'TEST4.CERN.CH'    ,'TEST4.IMPERIAL.AC.UK' ,'Active');
	test_create_channel('CHANNELCACHE_channel_1'    ,'TEST_CC.CERN.CH'  ,'TEST_CC.RAL.AC.UK'    ,'Active');
	test_create_channel('CHANNELCACHE_channel_2'    ,'TEST_CC.CERN.CH'  ,'TEST_CC.NIKHEF.NL'    ,'Active');
	test_create_channel('CHANNELCACHE_channel_3'    ,'TEST_CC.CERN.CH'  ,'TEST_CC.INFN.IT'      ,'Active');
	test_create_channel('CHANNELCACHE_channel_4'    ,'TEST_CC.CERN.CH'  ,'TEST_CC.IN2P3.FR'     ,'Active');
	test_create_channel('CHANNELCACHE_channel_5'    ,'TEST_CC.CERN.CH'  ,'*'                    ,'Active');
    
    -- Blacklist SEs
    test_create_bad_se('bad.cern.ch'    ,'this host is faulty','My DN');
    test_create_bad_se('BADSITE.INFN.IT','this site is bad'   ,'My DN');    
END;
/
