DECLARE
-- Insert Transfer Procedure
PROCEDURE test_create_transfer(
                            r    T_TRANSFER.REQUEST_ID%TYPE,
                            f    T_TRANSFER.FILE_ID%TYPE,
                            t    T_TRANSFER.TRANSFER_ID%TYPE,
                            st   T_TRANSFER.TRANSFER_STATE%TYPE,
                            tm   T_TRANSFER.TRANSFER_TIME%TYPE, 
                            d    T_TRANSFER.DURATION%TYPE,
                            re   T_TRANSFER.REASON_CLASS%TYPE DEFAULT NULL,
                            rs   T_TRANSFER.REASON%TYPE DEFAULT NULL)
IS
    j_id  T_TRANSFER.JOB_ID%TYPE;                        
BEGIN
    SELECT T_FILE.JOB_ID into j_id FROM T_FILE WHERE T_FILE.FILE_ID = f;
    INSERT INTO t_transfer(request_id,file_id,transfer_id,job_id,transfer_state,transfer_time,duration,reason_class,reason) 
        VALUES (r,f,t,j_id,st,tm,d,re,rs);
END;
-- Main
BEGIN
	-- Set Records
    test_create_transfer('10003'   ,10000003,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10205'   ,10000205,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10206'   ,10000206,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10233'   ,10000233,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10237'   ,10000237,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10238'   ,10000238,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10239'   ,10000239,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10240'   ,10000240,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10304'   ,10000304,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
   
    test_create_transfer('10401'   ,10000401,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10402'   ,10000402,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10403'   ,10000403,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10404'   ,10000404,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10405'   ,10000405,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10406'   ,10000406,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10407'   ,10000407,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10408'   ,10000408,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('10409'   ,10000409,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
   
      
    test_create_transfer('20004'   ,20000004,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('20006'   ,20000006,0,'Completed' ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('20007'   ,20000007,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('20015'   ,20000015,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('20015_1' ,20000015,0,'Failed'    ,TO_TIMESTAMP('20050102000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('20016'   ,20000016,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('20017'   ,20000017,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    --test_create_transfer('30001'   ,30000001,0,'Completed' ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    --test_create_transfer('30002'   ,30000002,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    --test_create_transfer('30004'   ,30000004,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    --test_create_transfer('30005'   ,30000005,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),1);
    --test_create_transfer('30006'   ,30000006,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),NULL);
    test_create_transfer('req_6_1' ,60000001,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_1' ,60000002,1,'Done'      ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_2' ,60000003,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_3' ,60000004,0,'Failed'    ,TO_TIMESTAMP('20250101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_4' ,60000005,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_4' ,60000006,1,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_5' ,60000007,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_5' ,60000008,1,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_6' ,60000007,0,'Failed'    ,TO_TIMESTAMP('20250101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_7' ,60000009,0,'Completed' ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_7' ,60000011,1,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_8' ,60000007,0,'Failed'    ,TO_TIMESTAMP('20250101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_9' ,60000007,0,'Failed'    ,TO_TIMESTAMP('20250101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_10',60000007,0,'Failed'    ,TO_TIMESTAMP('20250101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_6_26',60000026,0,'Failed'    ,TO_TIMESTAMP('20250101000000','YYYYMMDDHH24MISS'),10.1);
    
    -- ActiveTxCache test case
    test_create_transfer('req_7_1' ,70000001,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_1' ,70000002,1,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_2' ,70000003,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_2' ,70000004,1,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_3' ,70000005,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_4' ,70000006,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_5' ,70000007,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_5' ,70000008,1,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_6' ,70000009,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_6' ,70000010,1,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_7' ,70000011,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_7' ,70000012,1,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_7' ,70000013,2,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_8' ,70000014,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_9' ,70000015,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_10',70000016,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_10',70000017,1,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_11',70000018,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_11',70000019,1,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_12',70000020,0,'Processing',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);

    test_create_transfer('req_7_111',70000111,0,'Received',     TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_112',70000112,0,'Preparing',    TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_113',70000113,0,'Ready',        TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    
    test_create_transfer('req_7_121',70000121,0,'Submitted',    TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_122',70000122,0,'Processing',   TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_123',70000123,0,'Transferred',  TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    
    test_create_transfer('req_7_131',70000131,0,'Processing',   TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_132',70000132,0,'Processing',   TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
    test_create_transfer('req_7_133',70000133,0,'Completed',    TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1);
        
    /* smarter retry
    test_create_transfer('req_8_1_0' ,80000001,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'AGENT_ERROR'     ,'An error');
    test_create_transfer('req_8_2_0' ,80000002,0,'Failed'    ,SYSTIMESTAMP                                     ,10.1,'AGENT_ERROR'     ,'An error');
    test_create_transfer('req_8_3_0' ,80000003,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'SOURCE_SRM_ERROR','Failed on SRM get: SRM getRequestStatus timed out on get');
    test_create_transfer('req_8_4_0' ,80000004,0,'Failed'    ,SYSTIMESTAMP                                     ,10.1,'SOURCE_SRM_ERROR','Failed on SRM get: SRM getRequestStatus timed out on get');
    test_create_transfer('req_8_5_0' ,80000005,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'SOURCE_SRM_ERROR','Failed on SRM get');
    test_create_transfer('req_8_5_1' ,80000005,0,'Failed'    ,TO_TIMESTAMP('20060101000000','YYYYMMDDHH24MISS'),10.1,'SOURCE_SRM_ERROR','Failed on SRM get: SRM getRequestStatus timed out on get');
    test_create_transfer('req_8_6_0' ,80000006,0,'Failed'    ,SYSTIMESTAMP - INTERVAL '1' SECOND               ,10.1,'SOURCE_SRM_ERROR','Failed on SRM get');
    test_create_transfer('req_8_6_1' ,80000006,0,'Failed'    ,SYSTIMESTAMP                                     ,10.1,'SOURCE_SRM_ERROR','Failed on SRM get: SRM getRequestStatus timed out on get');
    test_create_transfer('req_8_7_0' ,80000007,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'SOURCE_SRM_ERROR','[SRM_INVALID_PATH] Failed on SRM get: Failed SRM get call. Error is specified file(s) does not exist');
    test_create_transfer('req_8_8_0' ,80000008,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'SOURCE_SRM_ERROR','An error');
    test_create_transfer('req_8_9_0' ,80000009,0,'Failed'    ,SYSTIMESTAMP                                     ,10.1,'SOURCE_SRM_ERROR','An error');
    test_create_transfer('req_8_10_0',80000010,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'DEST_SRM_ERROR'  ,'[SRM_DUPLICATION_ERROR] RequestFileStatus#-2147081737 failed with error:[ GetStorageInfoFailed : file exists, cannot write ]');
    test_create_transfer('req_8_11_0',80000011,0,'Failed'    ,SYSTIMESTAMP                                     ,10.1,'DEST_SRM_ERROR'  ,'[SRM_DUPLICATION_ERROR] RequestFileStatus#-2147081737 failed with error:[ GetStorageInfoFailed : file exists, cannot write ]');
    test_create_transfer('req_8_12_0',80000012,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'DEST_SRM_ERROR'  ,'An error');
    test_create_transfer('req_8_13_0',80000013,0,'Failed'    ,SYSTIMESTAMP                                     ,10.1,'DEST_SRM_ERROR'  ,'An error');
    test_create_transfer('req_8_14_0',80000014,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'SECURITY_ERROR'  ,'Invalid Credentials');
    test_create_transfer('req_8_15_0',80000015,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'CONFIGURATION_ERROR','Invalid Configuration');
    test_create_transfer('req_8_16_0',80000016,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'TRANSFER_ERROR'  ,'Transfer Failed');
    test_create_transfer('req_8_16_1',80000016,0,'Failed'    ,TO_TIMESTAMP('20060101000000','YYYYMMDDHH24MISS'),10.1,'DEST_SRM_ERROR'  ,'[SRM_DUPLICATION_ERROR] RequestFileStatus#-2147081737 failed with error:[ GetStorageInfoFailed : file exists, cannot write');
    test_create_transfer('req_8_17_0',80000017,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'NETWORK_ERROR'   ,'Transfer failed due to a possible network error');
    test_create_transfer('req_8_17_1',80000017,0,'Failed'    ,TO_TIMESTAMP('20060101000000','YYYYMMDDHH24MISS'),10.1,'DEST_PREP_SRM_ERROR','[SRM_DUPLICATION_ERROR] RequestFileStatus#-2147081737 failed with error:[ GetStorageInfoFailed : file exists, cannot write ]');
    test_create_transfer('req_8_18_0',80000018,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'TRANSFER_ERROR'  ,'An error');
    test_create_transfer('req_8_18_1',80000018,0,'Failed'    ,TO_TIMESTAMP('20050102000000','YYYYMMDDHH24MISS'),10.1,'TRANSFER_ERROR'  ,'An error');
    test_create_transfer('req_8_18_2',80000018,0,'Failed'    ,TO_TIMESTAMP('20050103000000','YYYYMMDDHH24MISS'),10.1,'TRANSFER_ERROR'  ,'An error');
    test_create_transfer('req_8_18_3',80000018,0,'Failed'    ,TO_TIMESTAMP('20050104000000','YYYYMMDDHH24MISS'),10.1,'TRANSFER_ERROR'  ,'An error');
    test_create_transfer('req_8_18_4',80000018,0,'Failed'    ,TO_TIMESTAMP('20050105000000','YYYYMMDDHH24MISS'),10.1,'DEST_SRM_ERROR'  ,'[SRM_DUPLICATION_ERROR] RequestFileStatus#-2147081737 failed with error:[ GetStorageInfoFailed : file exists, cannot write');
    test_create_transfer('req_8_19_0',80000019,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'TRANSFER_ERROR'  ,'file exists, cannot write');
    test_create_transfer('req_8_20_0',80000020,0,'Failed'    ,SYSTIMESTAMP                                     ,10.1,'TRANSFER_ERROR'  ,'file exists, cannot write');
    test_create_transfer('req_8_21_0',80000021,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'AGENT_ERROR'     ,'Inconsistency found: Invalid Request state returned by transfer-url-copy');
    test_create_transfer('req_8_21_1',80000021,0,'Failed'    ,TO_TIMESTAMP('20060101000000','YYYYMMDDHH24MISS'),10.1,'DEST_SRM_ERROR'  ,'[SRM_DUPLICATION_ERROR] RequestFileStatus#-2147081737 failed with error:[ GetStorageInfoFailed : file exists, cannot write');
    test_create_transfer('req_8_22_0',80000022,0,'Failed'    ,TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'),10.1,'SECURITY_ERROR'  ,'TRANSFER error during TRANSFER phase: [PERMISSION] 533 533 Permission denied');
    */
END;
/
