DECLARE
-- Insert Channel Procedure
PROCEDURE test_create_ch_vo_share(
                            n    T_CHANNEL_VO_SHARE.CHANNEL_NAME%TYPE,
                            v    T_CHANNEL_VO_SHARE.VO_NAME%TYPE,
                            s    T_CHANNEL_VO_SHARE.CHANNEL_SHARE%TYPE,
                            l    T_CHANNEL_VO_SHARE.CHANNEL_LIMIT%TYPE DEFAULT 0,
                            vs   T_CHANNEL_VO_SHARE.CHANNEL_VOSTATE%TYPE DEFAULT NULL)
IS                            
BEGIN
    INSERT INTO t_channel_vo_share(channel_name,vo_name,channel_share,channel_limit, channel_vostate) 
        VALUES (n,v,s,l,vs);
END;

-- Main
BEGIN
	-- Set Records
    test_create_ch_vo_share('channel_1'         ,'CHANNEL_VO_1' ,10);
    test_create_ch_vo_share('channel_1'         ,'CHANNEL_VO_2' ,10);
    test_create_ch_vo_share('channel_2'         ,'CHANNEL_VO_1' ,10);
    test_create_ch_vo_share('channel_2'         ,'CHANNEL_VO_2' ,10);
    test_create_ch_vo_share('channel_3'         ,'CHANNEL_VO_1' ,10);
    test_create_ch_vo_share('channel_3'         ,'CHANNEL_VO_2' ,10);
    test_create_ch_vo_share('channel_4'         ,'CHANNEL_VO_1' ,10);
    test_create_ch_vo_share('channel_4'         ,'CHANNEL_VO_2' ,10);
    test_create_ch_vo_share('channel_5'         ,'CHANNEL_VO_1' ,10);
    test_create_ch_vo_share('channel_5'         ,'CHANNEL_VO_2' ,10);
    test_create_ch_vo_share('channel_6'         ,'CHANNEL_VO_2' ,10);
    test_create_ch_vo_share('channel_6'         ,'CHANNEL_VO_3' ,10);
    test_create_ch_vo_share('channel_8'         ,'CHANNEL_VO_1' ,10);
    test_create_ch_vo_share('channel_9'         ,'CHANNEL_VO_1' ,10);
    test_create_ch_vo_share('channel_10'        ,'CHANNEL_VO_4' ,10,22,'ON');
    test_create_ch_vo_share('channel_10'        ,'CHANNEL_VO_5' ,10,0,'OFF');
    test_create_ch_vo_share('channel_10'        ,'CHANNEL_VO_6' ,10,5,'PAUSE');
    test_create_ch_vo_share('channel_11'        ,'CHANNEL_VO_1' ,10);
    test_create_ch_vo_share('channel_12'        ,'CHANNEL_VO_1' ,10);
    test_create_ch_vo_share('FILE_channel_1'    ,'FILE_VO_1'    ,10);
    test_create_ch_vo_share('FILE_channel_1'    ,'FILE_VO_2'    ,10);
    test_create_ch_vo_share('FILE_channel_3_SEL','FILE_VO_3_SEL',100);
    test_create_ch_vo_share('JOB_channel_1'     ,'JOB_VO_1'     ,10);
    test_create_ch_vo_share('JOB_channel_1'     ,'JOB_VO_2'     ,10);
    test_create_ch_vo_share('CREDJOB_channel_1' ,'CREDJOB_VO_1' ,10);
    test_create_ch_vo_share('TRANSFER_channel_1','TRANSFER_VO_1',10);
    test_create_ch_vo_share('TRANSFER_channel_1','TRANSFER_VO_2',10);
    test_create_ch_vo_share('STAGEREQ_channel_1','STAGEREQ_VO_1',10);
    test_create_ch_vo_share('STAGEREQ_channel_1','STAGEREQ_VO_2',10);
    test_create_ch_vo_share('CRED_channel_1'    ,'CRED_VO_1'    ,10);
    test_create_ch_vo_share('CRED_channel_1'    ,'CRED_VO_2'    ,10);
    -- for 3.1.0 specific tests
    test_create_ch_vo_share('channel_20'        ,'CHANNEL_VO_1' ,10);
    test_create_ch_vo_share('channel_23'        ,'CHANNEL_VO_1' ,10);
    -- for 3.2.0 specific tests
    test_create_ch_vo_share('channel_21'        ,'CHANNEL_VO_1' ,10);
    test_create_ch_vo_share('channel_22'        ,'CHANNEL_VO_1' ,10);
    -- for 3.3.0 specific tests
    test_create_ch_vo_share('channel_24'        ,'CHANNEL_VO_1' ,10);
    test_create_ch_vo_share('channel_25'        ,'CHANNEL_VO_1' ,10);
    -- GetShare tests and refactoring  
    test_create_ch_vo_share('GETSHARE_channel_1','GETSHARE_VO_1',10);
    test_create_ch_vo_share('GETSHARE_channel_1','GETSHARE_VO_2',10);

    test_create_ch_vo_share('GETSHARE_channel_2','GETSHARE_VO_1',10,1);
    test_create_ch_vo_share('GETSHARE_channel_2','GETSHARE_VO_2',10,10);

    test_create_ch_vo_share('GETSHARE_channel_3','GETSHARE_VO_1',10,80,'ON');
    test_create_ch_vo_share('GETSHARE_channel_3','GETSHARE_VO_2',10,80,'OFF');
    test_create_ch_vo_share('GETSHARE_channel_3','GETSHARE_VO_3',10,10,'PAUSE');
        
    test_create_ch_vo_share('GETSHARE_channel_4','GETSHARE_VO_1',25);
    test_create_ch_vo_share('GETSHARE_channel_4','GETSHARE_VO_2',25);
    test_create_ch_vo_share('GETSHARE_channel_4','GETSHARE_VO_3',25);
    test_create_ch_vo_share('GETSHARE_channel_4','GETSHARE_VO_4',25);

    test_create_ch_vo_share('GETSHARE_channel_5','GETSHARE_VO_1',25,10,'ON');
    test_create_ch_vo_share('GETSHARE_channel_5','GETSHARE_VO_2',25,10,'OFF');
    test_create_ch_vo_share('GETSHARE_channel_5','GETSHARE_VO_3',25,10,'PAUSE');
    test_create_ch_vo_share('GETSHARE_channel_5','GETSHARE_VO_4',25,10,'DENY');
            
END;
/
