DECLARE
-- Insert Credential Procedure
PROCEDURE test_create_credential(
                            i    T_CREDENTIAL.DLG_ID%TYPE,
                            d    T_CREDENTIAL.DN%TYPE,
                            c    VARCHAR2 DEFAULT NULL,
                            v    VARCHAR2 DEFAULT NULL,
                            tt   T_CREDENTIAL.TERMINATION_TIME%TYPE DEFAULT NULL)
IS
    c_tmp  T_CREDENTIAL.PROXY%TYPE;
    v_tmp  T_CREDENTIAL.VOMS_ATTRS%TYPE;
    tt_tmp T_CREDENTIAL.TERMINATION_TIME%TYPE;
BEGIN
    IF c IS NOT NULL THEN
        SELECT TO_CLOB(c) INTO c_tmp FROM DUAL;
    ELSE
        SELECT TO_CLOB('this is a fake entry for a certificate just to test the CredDAO') INTO c_tmp FROM DUAL;
    END IF;
    IF v IS NOT NULL THEN
        SELECT TO_CLOB(v) INTO v_tmp FROM DUAL;
    ELSE
        SELECT TO_CLOB('this is a fake entry for a voms attribute list just to test the CredDAO')  INTO v_tmp FROM DUAL;
    END IF;
    IF tt IS NOT NULL THEN
        tt_tmp := tt;
    ELSE
        SELECT (CURRENT_TIMESTAMP + INTERVAL '3600' SECOND) INTO tt_tmp FROM DUAL;
    END IF;
    
    INSERT INTO t_credential(dlg_id,dn,proxy,voms_attrs,termination_time) 
        VALUES (i,d,c_tmp,v_tmp,tt_tmp);
END;

-- Main
BEGIN
	-- Set Records
    test_create_credential('CRED_id_1' ,'My DN 1' ,NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '3600' SECOND);
    test_create_credential('CRED_id_2' ,'My DN 2' ,NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '3600' SECOND);
    test_create_credential('CRED_id_3' ,'My DN 3' ,NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '7200' SECOND);
    test_create_credential('CRED_id_4' ,'My DN 4' ,NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '1200' SECOND);
    test_create_credential('CRED_id_5' ,'My DN 5' ,NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '172800' SECOND);
    test_create_credential('CRED_id_6' ,'My DN 6' ,NULL,NULL,CURRENT_TIMESTAMP - INTERVAL '3600' SECOND);
    test_create_credential('CRED_id_7' ,'My DN 7' ,NULL,NULL,CURRENT_TIMESTAMP - INTERVAL '7200' SECOND);
    test_create_credential('CRED_id_8' ,'My DN 8' ,NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '864000' SECOND);
    test_create_credential('CRED_id_9' ,'My DN 9' ,NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '1800' SECOND);
    test_create_credential('CRED_id_10','My DN 10',NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '14400' SECOND);
    test_create_credential('CRED_id_11','My DN 11',NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '3600' SECOND);
    test_create_credential('CRED_id_12','My DN 12',NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '3600' SECOND);
    test_create_credential('CRED_id_13','My DN 13',NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '7200' SECOND);
    test_create_credential('CRED_id_14','My DN 14',NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '1200' SECOND);
    test_create_credential('CRED_id_15','My DN 15',NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '172800' SECOND);
    test_create_credential('CRED_id_16','My DN 16',NULL,NULL,CURRENT_TIMESTAMP - INTERVAL '3600' SECOND);
    test_create_credential('CRED_id_17','My DN 17',NULL,NULL,CURRENT_TIMESTAMP - INTERVAL '7200' SECOND);
    test_create_credential('CRED_id_18','My DN 18',NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '864000' SECOND);
    test_create_credential('CRED_id_19','My DN 19',NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '1800' SECOND);
    test_create_credential('CRED_id_20','My DN 20',NULL,NULL,CURRENT_TIMESTAMP + INTERVAL '14400' SECOND);
    
END;
/
