DECLARE

-- Insert Transfer Procedure
PROCEDURE test_create_transfer(
                            r    T_TRANSFER.REQUEST_ID%TYPE,
                            f    T_TRANSFER.FILE_ID%TYPE,
                            t    T_TRANSFER.TRANSFER_ID%TYPE,
                            st   T_TRANSFER.TRANSFER_STATE%TYPE,
                            src  T_TRANSFER.SOURCE_TURL%TYPE, 
                            dst  T_TRANSFER.DEST_TURL%TYPE,
                            tt   T_TRANSFER.TRANSFER_TIME%TYPE DEFAULT NULL)
IS
    j_id  T_TRANSFER.JOB_ID%TYPE;
BEGIN
    SELECT T_FILE.JOB_ID into j_id FROM T_FILE WHERE T_FILE.FILE_ID = f;
    INSERT INTO t_transfer(request_id,file_id,transfer_id,job_id,transfer_state,source_turl,dest_turl,transfer_time) 
        VALUES (r,f,t,j_id,st,src,dst,tt);
END;

-- Insert Transfer Procedure - 3.1.0 new properties
PROCEDURE test_create_transfer_3_1_0(
                            r               T_TRANSFER.REQUEST_ID%TYPE,
                            f               T_TRANSFER.FILE_ID%TYPE,
                            t               T_TRANSFER.TRANSFER_ID%TYPE,
                            st              T_TRANSFER.TRANSFER_STATE%TYPE,
                            reas            T_TRANSFER.REASON%TYPE,
                            reas_class      T_TRANSFER.REASON_CLASS%TYPE,
                            err_scope       T_TRANSFER.ERROR_SCOPE%TYPE,
                            err_phase       T_TRANSFER.ERROR_PHASE%TYPE)
IS
    j_id  T_TRANSFER.JOB_ID%TYPE;
BEGIN
    SELECT T_FILE.JOB_ID into j_id FROM T_FILE WHERE T_FILE.FILE_ID = f;
    INSERT INTO t_transfer(request_id,file_id,transfer_id,job_id,transfer_state,
        source_turl,dest_turl,
        reason,reason_class,error_scope,error_phase) 
    VALUES (r,f,t,j_id,st,
        'file:///tmp/src.txt','file:///tmp/dst.txt',
        reas,reas_class,err_scope,err_phase);
END;


-- Main
BEGIN
	-- Set Records
    test_create_transfer('req_3_1',30000001,0,'Processing','file:///tmp/src.txt','file:///tmp/dst.txt');
    test_create_transfer('req_3_1',30000002,1,'Completed' ,'file:///tmp/src.txt','file:///tmp/dst.txt');
    test_create_transfer('req_3_2',30000003,0,'Processing','file:///tmp/src.txt','file:///tmp/dst.txt');
    test_create_transfer('req_3_3',30000004,0,'Completed' ,'file:///tmp/src.txt','file:///tmp/dst.txt');
    test_create_transfer('req_3_3',30000005,1,'Failed'    ,'file:///tmp/src.txt','file:///tmp/dst.txt',TO_TIMESTAMP('20050101000000','YYYYMMDDHH24MISS'));
    test_create_transfer('req_3_4',30000005,0,'Failed'    ,'file:///tmp/src.txt','file:///tmp/dst.txt',TO_TIMESTAMP('20050201000000','YYYYMMDDHH24MISS'));
    test_create_transfer('req_3_5',30000007,0,'Processing','file:///tmp/src.txt','file:///tmp/dst.txt',TO_TIMESTAMP('20050201000000','YYYYMMDDHH24MISS'));
    test_create_transfer('req_3_6',30000008,0,'Processing','file:///tmp/src.txt','file:///tmp/dst.txt');
    test_create_transfer('req_3_7',30000009,0,'Processing','file:///tmp/src.txt','file:///tmp/dst.txt');
    test_create_transfer('req_4_1',40000001,0,'Processing','file:///tmp/src.txt','file:///tmp/dst.txt');
    test_create_transfer('req_4_2',40000002,0,'Processing','file:///tmp/src.txt','file:///tmp/dst.txt');
    -- 3.1.0
    test_create_transfer_3_1_0('req_5_1',60000004,0,'Failed','failure','SECURITY_ERROR','SOURCE','TRANSFER_PREPARATION');
    test_create_transfer_3_1_0('req_5_2',60000004,0,'Failed','failure','STORAGE_INTERNAL_ERROR','DESTINATION','TRANSFER');
    test_create_transfer_3_1_0('req_5_3',60000004,0,'Failed','failure','INTERNAL_ERROR','AGENT','TRANSFER_FINALIZATION');
    -- bug specific tests
    test_create_transfer('req_1_1',70000001,0,'Processing','file:///tmp/src.txt','file:///tmp/dst.txt');  
END;
/
