DECLARE
-- Insert Job Procedure
PROCEDURE test_create_job(
                            j    T_JOB.JOB_ID%TYPE,
                            st   T_JOB.JOB_STATE%TYPE,
                            dn   T_JOB.USER_DN%TYPE, 
                            cr   T_JOB.USER_CRED%TYPE,
                            vo   T_JOB.VO_NAME%TYPE, 
                            ch   T_JOB.CHANNEL_NAME%TYPE,
                            src  T_JOB.SOURCE%TYPE, 
                            dst  T_JOB.DEST%TYPE,
                            cj   T_JOB.CANCEL_JOB%TYPE DEFAULT NULL,
                            ip   T_JOB.INTERNAL_JOB_PARAMS%TYPE DEFAULT NULL,
                            jst  T_JOB.SUBMIT_TIME%TYPE DEFAULT NULL,
                            s_se T_JOB.SOURCE_SE%TYPE DEFAULT NULL, 
                            d_se T_JOB.DEST_SE%TYPE DEFAULT NULL)
IS         
    v_source_se VARCHAR2(256);
    v_dest_se   VARCHAR2(256);
BEGIN
    IF s_se IS NULL THEN
        v_source_se := src;
    ELSE 
        v_source_se := s_se;
    END IF;
    IF d_se IS NULL THEN
        v_dest_se := dst;
    ELSE 
        v_dest_se := d_se;
    END IF;
    
    IF jst IS NULL THEN
        INSERT INTO t_job(job_id,job_state,user_dn,user_cred,vo_name,channel_name,source,dest,cancel_job, internal_job_params, source_se, dest_se) 
            VALUES (j,st,dn,cr,vo,ch,src,dst,cj,ip, v_source_se, v_dest_se);
    ELSE 
        INSERT INTO t_job(job_id,job_state,user_dn,user_cred,vo_name,channel_name,source,dest,cancel_job, internal_job_params,submit_time, source_se, dest_se) 
            VALUES (j,st,dn,cr,vo,ch,src,dst,cj,ip,jst, v_source_se, v_dest_se);
    END IF;
END;

-- Main
BEGIN
    -- Set Records
    test_create_job('10000000-0000-0000-0000-000000000401','Active','DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000402','Active','DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000403','Active','DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000404','Active','DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000405','Active','DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000406','Active','DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000407','Active','DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000408','Active','DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000409','Active','DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000410','Ready' ,'DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000411','Ready' ,'DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000412','Ready' ,'DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000413','Ready' ,'DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000414','Ready' ,'DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000415','Ready' ,'DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000416','Ready' ,'DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000417','Ready' ,'DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000418','Ready' ,'DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000419','Ready' ,'DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000420','Ready' ,'DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000421','Ready' ,'DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
    test_create_job('10000000-0000-0000-0000-000000000422','Ready' ,'DN','MyCred','VO_1','channel_30271','TEST30271.CERN.CH','TEST30271.INFN.IT',NULL,NULL,  SYSTIMESTAMP - INTERVAL '34' SECOND);
END;
/
