#!/bin/bash
# Copyright (c) Members of the EGEE Collaboration. 2004.
# See http://www.eu-egee.org/partners/ for details on the copyright holders.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Install Scheduler UnitTest Data
test_scheduler_install__DEPENDS="init_unit_test"
function test_scheduler_install(){

    # Create Template for the UnitTest 
    create_config_xml "glite-transfer-agent-test-scheduler" ${MODULE_TEST_DIR}/etc/glite-transfer-agent-test-scheduler.config.xml \
        ${AGENTS_COMMON_CONFIG_TEMPLATES}/agents-dao-oracle.config-template.xml \
        ${MODULE_CONFIG_TEMPLATES}/transfer-agent-scheduler.config-template.xml \
        ${MODULE_DIR}/test/scheduler/etc/transfer-agent-test-scheduler.config-template.xml
    # Create UnitTest configuration                                   
    config_generator -f ${MODULE_TEST_DIR}/etc/glite-transfer-agent-test-scheduler.config.xml \
        -o ${MODULE_TEST_DIR}/etc/glite-transfer-agent-test-scheduler.properties.xml \
        -l ${MODULE_TEST_DIR}/etc/glite-transfer-agent-test-scheduler.log-properties \
        -O agents-dao-oracle.User=${ORA_USER} \
        -O agents-dao-oracle.Password=${ORA_PWD} \
        -O agents-dao-oracle.ConnectString=${ORA_CONNECTSTRING} \
        -O transfer-agent-scheduler.MaxFailures=1 \
        -O transfer-agent-scheduler.DisableTime=4 \
        -O log.fileName=${MODULE_TEST_DIR}/var/log/transfer-agent-test-scheduler.log \
        -O log.Priority=DEBUG
}

# Scheduler Unit Test 
test_scheduler__DEPENDS="test_scheduler_install"
function test_scheduler(){
    (cd ${MODULE_TEST_DIR}/bin && \
        ${MODULE_TEST_DIR}/bin/glite_data_transfer_agent_test_scheduler -l ${MODULE_TEST_DIR} -s) || return ${?}
}
